/* keys.c generated by valac 0.22.1, the Vala compiler
 * generated from keys.vala, do not modify */

/*
 Copyright (C) 2009-2014 Christian Dywan <christian@twotoasts.de>
 Copyright (C) 2009-2012 Alexander Butenko <a.butenka@gmail.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define ADBLOCK_TYPE_FEATURE (adblock_feature_get_type ())
#define ADBLOCK_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeature))
#define ADBLOCK_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))
#define ADBLOCK_IS_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_IS_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_FEATURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))

typedef struct _AdblockFeature AdblockFeature;
typedef struct _AdblockFeatureClass AdblockFeatureClass;
typedef struct _AdblockFeaturePrivate AdblockFeaturePrivate;

#define ADBLOCK_TYPE_DIRECTIVE (adblock_directive_get_type ())

#define ADBLOCK_TYPE_FILTER (adblock_filter_get_type ())
#define ADBLOCK_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_FILTER, AdblockFilter))
#define ADBLOCK_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_FILTER, AdblockFilterClass))
#define ADBLOCK_IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_FILTER))
#define ADBLOCK_IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_FILTER))
#define ADBLOCK_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_FILTER, AdblockFilterClass))

typedef struct _AdblockFilter AdblockFilter;
typedef struct _AdblockFilterClass AdblockFilterClass;
typedef struct _AdblockFilterPrivate AdblockFilterPrivate;

#define ADBLOCK_TYPE_KEYS (adblock_keys_get_type ())
#define ADBLOCK_KEYS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_KEYS, AdblockKeys))
#define ADBLOCK_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_KEYS, AdblockKeysClass))
#define ADBLOCK_IS_KEYS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_KEYS))
#define ADBLOCK_IS_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_KEYS))
#define ADBLOCK_KEYS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_KEYS, AdblockKeysClass))

typedef struct _AdblockKeys AdblockKeys;
typedef struct _AdblockKeysClass AdblockKeysClass;
typedef struct _AdblockKeysPrivate AdblockKeysPrivate;
#define __g_list_free__g_regex_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_regex_unref0_ (var), NULL)))

#define ADBLOCK_TYPE_OPTIONS (adblock_options_get_type ())
#define ADBLOCK_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_OPTIONS, AdblockOptions))
#define ADBLOCK_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_OPTIONS, AdblockOptionsClass))
#define ADBLOCK_IS_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_OPTIONS))
#define ADBLOCK_IS_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_OPTIONS))
#define ADBLOCK_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_OPTIONS, AdblockOptionsClass))

typedef struct _AdblockOptions AdblockOptions;
typedef struct _AdblockOptionsClass AdblockOptionsClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

typedef enum  {
	ADBLOCK_DIRECTIVE_ALLOW,
	ADBLOCK_DIRECTIVE_BLOCK
} AdblockDirective;

struct _AdblockFeature {
	GObject parent_instance;
	AdblockFeaturePrivate * priv;
};

struct _AdblockFeatureClass {
	GObjectClass parent_class;
	gboolean (*header) (AdblockFeature* self, const gchar* key, const gchar* value);
	gboolean (*parsed) (AdblockFeature* self, GFile* file);
	AdblockDirective* (*match) (AdblockFeature* self, const gchar* request_uri, const gchar* page_uri, GError** error);
	void (*clear) (AdblockFeature* self);
};

struct _AdblockFilter {
	AdblockFeature parent_instance;
	AdblockFilterPrivate * priv;
	GHashTable* rules;
};

struct _AdblockFilterClass {
	AdblockFeatureClass parent_class;
	void (*insert) (AdblockFilter* self, const gchar* sig, GRegex* regex);
	GRegex* (*lookup) (AdblockFilter* self, const gchar* sig);
	guint (*size) (AdblockFilter* self);
};

struct _AdblockKeys {
	AdblockFilter parent_instance;
	AdblockKeysPrivate * priv;
};

struct _AdblockKeysClass {
	AdblockFilterClass parent_class;
};

struct _AdblockKeysPrivate {
	GList* blacklist;
};


static gpointer adblock_keys_parent_class = NULL;

GType adblock_feature_get_type (void) G_GNUC_CONST;
GType adblock_directive_get_type (void) G_GNUC_CONST;
GType adblock_filter_get_type (void) G_GNUC_CONST;
GType adblock_keys_get_type (void) G_GNUC_CONST;
#define ADBLOCK_KEYS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ADBLOCK_TYPE_KEYS, AdblockKeysPrivate))
enum  {
	ADBLOCK_KEYS_DUMMY_PROPERTY
};
static void _g_regex_unref0_ (gpointer var);
static void _g_list_free__g_regex_unref0_ (GList* self);
GType adblock_options_get_type (void) G_GNUC_CONST;
AdblockKeys* adblock_keys_new (AdblockOptions* options);
AdblockKeys* adblock_keys_construct (GType object_type, AdblockOptions* options);
AdblockFilter* adblock_filter_construct (GType object_type, AdblockOptions* options);
static void adblock_keys_real_clear (AdblockFeature* base);
void adblock_feature_clear (AdblockFeature* self);
static AdblockDirective* adblock_keys_real_match (AdblockFeature* base, const gchar* request_uri, const gchar* page_uri, GError** error);
gchar* adblock_fixup_regex (const gchar* prefix, const gchar* src);
gboolean adblock_filter_check_rule (AdblockFilter* self, GRegex* regex, const gchar* pattern, const gchar* request_uri, const gchar* page_uri, GError** error);
static AdblockDirective* _adblock_directive_dup (AdblockDirective* self);
static void adblock_keys_finalize (GObject* obj);


static void _g_regex_unref0_ (gpointer var) {
#line 15 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	(var == NULL) ? NULL : (var = (g_regex_unref (var), NULL));
#line 145 "keys.c"
}


static void _g_list_free__g_regex_unref0_ (GList* self) {
#line 15 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	g_list_foreach (self, (GFunc) _g_regex_unref0_, NULL);
#line 15 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	g_list_free (self);
#line 154 "keys.c"
}


AdblockKeys* adblock_keys_construct (GType object_type, AdblockOptions* options) {
	AdblockKeys * self = NULL;
	AdblockOptions* _tmp0_ = NULL;
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	g_return_val_if_fail (options != NULL, NULL);
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_tmp0_ = options;
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	self = (AdblockKeys*) adblock_filter_construct (object_type, _tmp0_);
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	return self;
#line 169 "keys.c"
}


AdblockKeys* adblock_keys_new (AdblockOptions* options) {
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	return adblock_keys_construct (ADBLOCK_TYPE_KEYS, options);
#line 176 "keys.c"
}


static void adblock_keys_real_clear (AdblockFeature* base) {
	AdblockKeys * self;
#line 21 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	self = (AdblockKeys*) base;
#line 22 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	ADBLOCK_FEATURE_CLASS (adblock_keys_parent_class)->clear ((AdblockFeature*) G_TYPE_CHECK_INSTANCE_CAST (self, ADBLOCK_TYPE_FILTER, AdblockFilter));
#line 23 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	__g_list_free__g_regex_unref0_0 (self->priv->blacklist);
#line 23 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	self->priv->blacklist = NULL;
#line 190 "keys.c"
}


static const gchar* string_offset (const gchar* self, glong offset) {
	const gchar* result = NULL;
	glong _tmp0_ = 0L;
#line 1004 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1005 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = offset;
#line 1005 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + _tmp0_);
#line 1005 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 205 "keys.c"
}


static gpointer _g_regex_ref0 (gpointer self) {
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	return self ? g_regex_ref (self) : NULL;
#line 212 "keys.c"
}


static AdblockDirective* _adblock_directive_dup (AdblockDirective* self) {
	AdblockDirective* dup;
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	dup = g_new0 (AdblockDirective, 1);
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	memcpy (dup, self, sizeof (AdblockDirective));
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	return dup;
#line 224 "keys.c"
}


static gpointer __adblock_directive_dup0 (gpointer self) {
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	return self ? _adblock_directive_dup (self) : NULL;
#line 231 "keys.c"
}


static AdblockDirective* adblock_keys_real_match (AdblockFeature* base, const gchar* request_uri, const gchar* page_uri, GError** error) {
	AdblockKeys * self;
	AdblockDirective* result = NULL;
	gchar* uri = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint signature_size = 0;
	gint pos = 0;
	gint l = 0;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GError * _inner_error_ = NULL;
#line 26 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	self = (AdblockKeys*) base;
#line 26 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	g_return_val_if_fail (request_uri != NULL, NULL);
#line 26 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	g_return_val_if_fail (page_uri != NULL, NULL);
#line 27 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_tmp0_ = request_uri;
#line 27 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_tmp1_ = adblock_fixup_regex ("", _tmp0_);
#line 27 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	uri = _tmp1_;
#line 28 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_tmp2_ = uri;
#line 28 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	if (_tmp2_ == NULL) {
#line 29 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		result = NULL;
#line 29 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		_g_free0 (uri);
#line 29 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		return result;
#line 271 "keys.c"
	}
#line 31 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	signature_size = 8;
#line 32 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_tmp3_ = uri;
#line 32 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_tmp4_ = strlen (_tmp3_);
#line 32 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_tmp5_ = _tmp4_;
#line 32 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	l = _tmp5_;
#line 283 "keys.c"
	{
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gboolean _tmp8_ = FALSE;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		_tmp6_ = l;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		_tmp7_ = signature_size;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		pos = _tmp6_ - _tmp7_;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		_tmp8_ = TRUE;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
		while (TRUE) {
#line 298 "keys.c"
			gboolean _tmp9_ = FALSE;
			gint _tmp11_ = 0;
			gchar* signature = NULL;
			const gchar* _tmp12_ = NULL;
			gint _tmp13_ = 0;
			const gchar* _tmp14_ = NULL;
			gint _tmp15_ = 0;
			gchar* _tmp16_ = NULL;
			GRegex* regex = NULL;
			GHashTable* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
			gconstpointer _tmp19_ = NULL;
			GRegex* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			GRegex* _tmp22_ = NULL;
			gboolean _tmp26_ = FALSE;
			gboolean _tmp27_ = FALSE;
			GRegex* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			const gchar* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			gboolean _tmp32_ = FALSE;
			GRegex* _tmp35_ = NULL;
			GRegex* _tmp36_ = NULL;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp9_ = _tmp8_;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			if (!_tmp9_) {
#line 327 "keys.c"
				gint _tmp10_ = 0;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp10_ = pos;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				pos = _tmp10_ - 1;
#line 333 "keys.c"
			}
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp8_ = FALSE;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp11_ = pos;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			if (!(_tmp11_ >= 0)) {
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				break;
#line 343 "keys.c"
			}
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp12_ = uri;
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp13_ = pos;
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp14_ = string_offset (_tmp12_, (glong) _tmp13_);
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp15_ = signature_size;
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp16_ = g_strndup (_tmp14_, (gsize) _tmp15_);
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			signature = _tmp16_;
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp17_ = ((AdblockFilter*) self)->rules;
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp18_ = signature;
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp19_ = g_hash_table_lookup (_tmp17_, _tmp18_);
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp20_ = _g_regex_ref0 ((GRegex*) _tmp19_);
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			regex = _tmp20_;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp22_ = regex;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			if (_tmp22_ == NULL) {
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp21_ = TRUE;
#line 373 "keys.c"
			} else {
				GList* _tmp23_ = NULL;
				GRegex* _tmp24_ = NULL;
				GList* _tmp25_ = NULL;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp23_ = self->priv->blacklist;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp24_ = regex;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp25_ = g_list_find (_tmp23_, _tmp24_);
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp21_ = _tmp25_ != NULL;
#line 386 "keys.c"
			}
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp26_ = _tmp21_;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			if (_tmp26_) {
#line 37 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_regex_unref0 (regex);
#line 37 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_free0 (signature);
#line 37 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				continue;
#line 398 "keys.c"
			}
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp28_ = regex;
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp29_ = uri;
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp30_ = request_uri;
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp31_ = page_uri;
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp32_ = adblock_filter_check_rule ((AdblockFilter*) self, _tmp28_, _tmp29_, _tmp30_, _tmp31_, &_inner_error_);
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp27_ = _tmp32_;
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			if (_inner_error_ != NULL) {
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				g_propagate_error (error, _inner_error_);
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_regex_unref0 (regex);
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_free0 (signature);
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_free0 (uri);
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				return NULL;
#line 424 "keys.c"
			}
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			if (_tmp27_) {
#line 428 "keys.c"
				AdblockDirective _tmp33_ = 0;
				AdblockDirective* _tmp34_ = NULL;
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp33_ = ADBLOCK_DIRECTIVE_BLOCK;
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_tmp34_ = __adblock_directive_dup0 (&_tmp33_);
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				result = _tmp34_;
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_regex_unref0 (regex);
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_free0 (signature);
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				_g_free0 (uri);
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
				return result;
#line 445 "keys.c"
			}
#line 41 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp35_ = regex;
#line 41 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_tmp36_ = _g_regex_ref0 (_tmp35_);
#line 41 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			self->priv->blacklist = g_list_prepend (self->priv->blacklist, _tmp36_);
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_g_regex_unref0 (regex);
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
			_g_free0 (signature);
#line 457 "keys.c"
		}
	}
#line 44 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	result = NULL;
#line 44 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	_g_free0 (uri);
#line 44 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	return result;
#line 466 "keys.c"
}


static void adblock_keys_class_init (AdblockKeysClass * klass) {
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	adblock_keys_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	g_type_class_add_private (klass, sizeof (AdblockKeysPrivate));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	ADBLOCK_FEATURE_CLASS (klass)->clear = adblock_keys_real_clear;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	ADBLOCK_FEATURE_CLASS (klass)->match = adblock_keys_real_match;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	G_OBJECT_CLASS (klass)->finalize = adblock_keys_finalize;
#line 481 "keys.c"
}


static void adblock_keys_instance_init (AdblockKeys * self) {
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	self->priv = ADBLOCK_KEYS_GET_PRIVATE (self);
#line 488 "keys.c"
}


static void adblock_keys_finalize (GObject* obj) {
	AdblockKeys * self;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ADBLOCK_TYPE_KEYS, AdblockKeys);
#line 15 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	__g_list_free__g_regex_unref0_0 (self->priv->blacklist);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/keys.vala"
	G_OBJECT_CLASS (adblock_keys_parent_class)->finalize (obj);
#line 500 "keys.c"
}


GType adblock_keys_get_type (void) {
	static volatile gsize adblock_keys_type_id__volatile = 0;
	if (g_once_init_enter (&adblock_keys_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AdblockKeysClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adblock_keys_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdblockKeys), 0, (GInstanceInitFunc) adblock_keys_instance_init, NULL };
		GType adblock_keys_type_id;
		adblock_keys_type_id = g_type_register_static (ADBLOCK_TYPE_FILTER, "AdblockKeys", &g_define_type_info, 0);
		g_once_init_leave (&adblock_keys_type_id__volatile, adblock_keys_type_id);
	}
	return adblock_keys_type_id__volatile;
}



