/* updater.c generated by valac 0.22.1, the Vala compiler
 * generated from updater.vala, do not modify */

/*
 Copyright (C) 2014 Paweł Forysiuk <tuxator@o2.pl>
 Copyright (C) 2014 Christian Dywan <christian@twotoasts.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define ADBLOCK_TYPE_FEATURE (adblock_feature_get_type ())
#define ADBLOCK_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeature))
#define ADBLOCK_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))
#define ADBLOCK_IS_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_IS_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_FEATURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))

typedef struct _AdblockFeature AdblockFeature;
typedef struct _AdblockFeatureClass AdblockFeatureClass;
typedef struct _AdblockFeaturePrivate AdblockFeaturePrivate;

#define ADBLOCK_TYPE_DIRECTIVE (adblock_directive_get_type ())

#define ADBLOCK_TYPE_UPDATER (adblock_updater_get_type ())
#define ADBLOCK_UPDATER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_UPDATER, AdblockUpdater))
#define ADBLOCK_UPDATER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_UPDATER, AdblockUpdaterClass))
#define ADBLOCK_IS_UPDATER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_UPDATER))
#define ADBLOCK_IS_UPDATER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_UPDATER))
#define ADBLOCK_UPDATER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_UPDATER, AdblockUpdaterClass))

typedef struct _AdblockUpdater AdblockUpdater;
typedef struct _AdblockUpdaterClass AdblockUpdaterClass;
typedef struct _AdblockUpdaterPrivate AdblockUpdaterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

typedef enum  {
	ADBLOCK_DIRECTIVE_ALLOW,
	ADBLOCK_DIRECTIVE_BLOCK
} AdblockDirective;

struct _AdblockFeature {
	GObject parent_instance;
	AdblockFeaturePrivate * priv;
};

struct _AdblockFeatureClass {
	GObjectClass parent_class;
	gboolean (*header) (AdblockFeature* self, const gchar* key, const gchar* value);
	gboolean (*parsed) (AdblockFeature* self, GFile* file);
	AdblockDirective* (*match) (AdblockFeature* self, const gchar* request_uri, const gchar* page_uri, GError** error);
	void (*clear) (AdblockFeature* self);
};

struct _AdblockUpdater {
	AdblockFeature parent_instance;
	AdblockUpdaterPrivate * priv;
};

struct _AdblockUpdaterClass {
	AdblockFeatureClass parent_class;
};

struct _AdblockUpdaterPrivate {
	gchar* expires_meta;
	gchar* last_mod_meta;
	GDateTime* _last_updated;
	GDateTime* _expires;
	gboolean _needs_update;
};


static gpointer adblock_updater_parent_class = NULL;

GType adblock_feature_get_type (void) G_GNUC_CONST;
GType adblock_directive_get_type (void) G_GNUC_CONST;
GType adblock_updater_get_type (void) G_GNUC_CONST;
#define ADBLOCK_UPDATER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ADBLOCK_TYPE_UPDATER, AdblockUpdaterPrivate))
enum  {
	ADBLOCK_UPDATER_DUMMY_PROPERTY,
	ADBLOCK_UPDATER_LAST_UPDATED,
	ADBLOCK_UPDATER_EXPIRES,
	ADBLOCK_UPDATER_NEEDS_UPDATE
};
AdblockUpdater* adblock_updater_new (void);
AdblockUpdater* adblock_updater_construct (GType object_type);
AdblockFeature* adblock_feature_construct (GType object_type);
static void adblock_updater_real_clear (AdblockFeature* base);
void adblock_updater_set_last_updated (AdblockUpdater* self, GDateTime* value);
void adblock_updater_set_expires (AdblockUpdater* self, GDateTime* value);
void adblock_updater_set_needs_update (AdblockUpdater* self, gboolean value);
static gboolean adblock_updater_real_header (AdblockFeature* base, const gchar* key, const gchar* value);
static gboolean adblock_updater_real_parsed (AdblockFeature* base, GFile* file);
static void adblock_updater_process_dates (AdblockUpdater* self, GFile* file);
static gint adblock_updater_get_month_from_string (AdblockUpdater* self, const gchar* month);
GDateTime* adblock_updater_get_last_updated (AdblockUpdater* self);
GDateTime* adblock_updater_get_expires (AdblockUpdater* self);
gboolean adblock_updater_get_needs_update (AdblockUpdater* self);
static void adblock_updater_finalize (GObject* obj);
static void _vala_adblock_updater_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_adblock_updater_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


AdblockUpdater* adblock_updater_construct (GType object_type) {
	AdblockUpdater * self = NULL;
#line 21 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self = (AdblockUpdater*) adblock_feature_construct (object_type);
#line 21 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return self;
#line 126 "updater.c"
}


AdblockUpdater* adblock_updater_new (void) {
#line 21 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return adblock_updater_construct (ADBLOCK_TYPE_UPDATER);
#line 133 "updater.c"
}


static void adblock_updater_real_clear (AdblockFeature* base) {
	AdblockUpdater * self;
#line 24 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self = (AdblockUpdater*) base;
#line 25 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_free0 (self->priv->expires_meta);
#line 25 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self->priv->expires_meta = NULL;
#line 26 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_free0 (self->priv->last_mod_meta);
#line 26 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self->priv->last_mod_meta = NULL;
#line 27 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_set_last_updated (self, NULL);
#line 28 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_set_expires (self, NULL);
#line 29 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_set_needs_update (self, FALSE);
#line 155 "updater.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 178 "updater.c"
		glong _tmp4_ = 0L;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 186 "updater.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 198 "updater.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
#line 1167 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 223 "updater.c"
		glong _tmp2_ = 0L;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 229 "updater.c"
	} else {
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 233 "updater.c"
	}
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 239 "updater.c"
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 251 "updater.c"
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 261 "updater.c"
	}
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 267 "updater.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 281 "updater.c"
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 291 "updater.c"
	}
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 297 "updater.c"
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 306 "updater.c"
	}
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 326 "updater.c"
}


static gboolean adblock_updater_real_header (AdblockFeature* base, const gchar* key, const gchar* value) {
	AdblockUpdater * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 32 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self = (AdblockUpdater*) base;
#line 32 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 32 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp1_ = key;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp2_ = g_str_has_prefix (_tmp1_, "Last mod");
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	if (_tmp2_) {
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp0_ = TRUE;
#line 351 "updater.c"
	} else {
		const gchar* _tmp3_ = NULL;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp3_ = key;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, "Updated") == 0;
#line 358 "updater.c"
	}
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp4_ = _tmp0_;
#line 33 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	if (_tmp4_) {
#line 364 "updater.c"
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp5_ = value;
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_g_free0 (self->priv->last_mod_meta);
#line 34 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		self->priv->last_mod_meta = _tmp6_;
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		result = TRUE;
#line 35 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		return result;
#line 379 "updater.c"
	} else {
		const gchar* _tmp7_ = NULL;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp7_ = key;
#line 36 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		if (g_strcmp0 (_tmp7_, "Expires") == 0) {
#line 386 "updater.c"
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
#line 38 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp8_ = value;
#line 38 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 38 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_g_free0 (self->priv->expires_meta);
#line 38 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			self->priv->expires_meta = _tmp9_;
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			result = TRUE;
#line 39 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			return result;
#line 401 "updater.c"
		} else {
			const gchar* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp10_ = key;
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp11_ = g_str_has_prefix (_tmp10_, "! This list expires after");
#line 40 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp11_) {
#line 411 "updater.c"
				const gchar* _tmp12_ = NULL;
				gchar* _tmp13_ = NULL;
#line 42 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp12_ = key;
#line 42 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp13_ = string_substring (_tmp12_, (glong) 26, (glong) (-1));
#line 42 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_g_free0 (self->priv->expires_meta);
#line 42 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				self->priv->expires_meta = _tmp13_;
#line 43 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				result = TRUE;
#line 43 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				return result;
#line 426 "updater.c"
			}
		}
	}
#line 45 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	result = FALSE;
#line 45 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return result;
#line 434 "updater.c"
}


static gboolean adblock_updater_real_parsed (AdblockFeature* base, GFile* file) {
	AdblockUpdater * self;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
#line 48 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self = (AdblockUpdater*) base;
#line 48 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 49 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = file;
#line 49 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_process_dates (self, _tmp0_);
#line 51 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	result = TRUE;
#line 51 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return result;
#line 454 "updater.c"
}


static gint adblock_updater_get_month_from_string (AdblockUpdater* self, const gchar* month) {
	gint result = 0;
	const gchar* _tmp0_ = NULL;
	gchar** months = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar** _tmp13_ = NULL;
	gint months_length1 = 0;
	gint _months_size_ = 0;
#line 54 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 55 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = month;
#line 55 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	if (_tmp0_ == NULL) {
#line 56 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		result = 0;
#line 56 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		return result;
#line 487 "updater.c"
	}
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp1_ = g_strdup ("Jan");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp2_ = g_strdup ("Feb");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp3_ = g_strdup ("Mar");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp4_ = g_strdup ("Apr");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp5_ = g_strdup ("May");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp6_ = g_strdup ("Jun");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp7_ = g_strdup ("Jul");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp8_ = g_strdup ("Aug");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp9_ = g_strdup ("Sep");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp10_ = g_strdup ("Oct");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp11_ = g_strdup ("Nov");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp12_ = g_strdup ("Dec");
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_ = g_new0 (gchar*, 12 + 1);
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[0] = _tmp1_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[1] = _tmp2_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[2] = _tmp3_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[3] = _tmp4_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[4] = _tmp5_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[5] = _tmp6_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[6] = _tmp7_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[7] = _tmp8_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[8] = _tmp9_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[9] = _tmp10_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[10] = _tmp11_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp13_[11] = _tmp12_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	months = _tmp13_;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	months_length1 = 12;
#line 58 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_months_size_ = months_length1;
#line 545 "updater.c"
	{
		gint i = 0;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		i = 0;
#line 550 "updater.c"
		{
			gboolean _tmp14_ = FALSE;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp14_ = TRUE;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			while (TRUE) {
#line 557 "updater.c"
				gboolean _tmp15_ = FALSE;
				gint _tmp17_ = 0;
				gchar** _tmp18_ = NULL;
				gint _tmp18__length1 = 0;
				const gchar* _tmp19_ = NULL;
				gchar** _tmp20_ = NULL;
				gint _tmp20__length1 = 0;
				gint _tmp21_ = 0;
				const gchar* _tmp22_ = NULL;
				gboolean _tmp23_ = FALSE;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp15_ = _tmp14_;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				if (!_tmp15_) {
#line 572 "updater.c"
					gint _tmp16_ = 0;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					_tmp16_ = i;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					i = _tmp16_ + 1;
#line 578 "updater.c"
				}
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp14_ = FALSE;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp17_ = i;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp18_ = months;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp18__length1 = months_length1;
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				if (!(_tmp17_ <= _tmp18__length1)) {
#line 59 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					break;
#line 592 "updater.c"
				}
#line 61 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp19_ = month;
#line 61 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp20_ = months;
#line 61 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp20__length1 = months_length1;
#line 61 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp21_ = i;
#line 61 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp22_ = _tmp20_[_tmp21_];
#line 61 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp23_ = g_str_has_prefix (_tmp19_, _tmp22_);
#line 61 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				if (_tmp23_) {
#line 608 "updater.c"
					gint _tmp24_ = 0;
#line 62 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					_tmp24_ = i;
#line 62 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					result = _tmp24_ + 1;
#line 62 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					months = (_vala_array_free (months, months_length1, (GDestroyNotify) g_free), NULL);
#line 62 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					return result;
#line 618 "updater.c"
				}
			}
		}
	}
#line 64 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	result = 0;
#line 64 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	months = (_vala_array_free (months, months_length1, (GDestroyNotify) g_free), NULL);
#line 64 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return result;
#line 629 "updater.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 1237 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1237 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1238 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 649 "updater.c"
}


static void adblock_updater_process_dates (AdblockUpdater* self, GFile* file) {
	GDateTime* now = NULL;
	GDateTime* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp108_ = NULL;
	GDateTime* _tmp135_ = NULL;
	GDateTime* _tmp136_ = NULL;
	gint _tmp137_ = 0;
#line 67 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_if_fail (self != NULL);
#line 67 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_if_fail (file != NULL);
#line 68 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 68 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	now = _tmp0_;
#line 69 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_set_last_updated (self, NULL);
#line 70 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_set_expires (self, NULL);
#line 73 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp1_ = self->priv->last_mod_meta;
#line 73 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	if (_tmp1_ != NULL) {
#line 677 "updater.c"
		gint h = 0;
		gint min = 0;
		gint d = 0;
		gint m = 0;
		gint y = 0;
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gint _tmp100_ = 0;
		gint _tmp101_ = 0;
		gint _tmp102_ = 0;
		gint _tmp103_ = 0;
		gint _tmp104_ = 0;
		GDateTime* _tmp105_ = NULL;
		GDateTime* _tmp106_ = NULL;
#line 74 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		h = 0;
#line 74 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		min = 0;
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp3_ = self->priv->last_mod_meta;
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp4_ = string_contains (_tmp3_, ".");
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		if (_tmp4_) {
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp2_ = TRUE;
#line 706 "updater.c"
		} else {
			const gchar* _tmp5_ = NULL;
			gboolean _tmp6_ = FALSE;
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp5_ = self->priv->last_mod_meta;
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp6_ = string_contains (_tmp5_, "-");
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp2_ = _tmp6_;
#line 716 "updater.c"
		}
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp7_ = _tmp2_;
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		if (_tmp7_) {
#line 722 "updater.c"
			gchar** parts = NULL;
			const gchar* _tmp8_ = NULL;
			gchar** _tmp9_ = NULL;
			gchar** _tmp10_ = NULL;
			gint parts_length1 = 0;
			gint _parts_size_ = 0;
			gchar** date_parts = NULL;
			gint date_parts_length1 = 0;
			gint _date_parts_size_ = 0;
			gchar* split_char = NULL;
			gchar* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			gchar** _tmp13_ = NULL;
			gint _tmp13__length1 = 0;
			const gchar* _tmp14_ = NULL;
			gboolean _tmp18_ = FALSE;
			gchar** _tmp29_ = NULL;
			gint _tmp29__length1 = 0;
			const gchar* _tmp30_ = NULL;
			gboolean _tmp31_ = FALSE;
			gchar** _tmp37_ = NULL;
			gint _tmp37__length1 = 0;
			const gchar* _tmp38_ = NULL;
			const gchar* _tmp39_ = NULL;
			gchar** _tmp40_ = NULL;
			gchar** _tmp41_ = NULL;
			gchar** _tmp42_ = NULL;
			gint _tmp42__length1 = 0;
			const gchar* _tmp43_ = NULL;
			gint _tmp44_ = 0;
			gchar** _tmp45_ = NULL;
			gint _tmp45__length1 = 0;
			const gchar* _tmp46_ = NULL;
			gint _tmp47_ = 0;
			gint _tmp48_ = 0;
#line 77 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp8_ = self->priv->last_mod_meta;
#line 77 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, " ", 2);
#line 77 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts = _tmp10_;
#line 77 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts_length1 = _vala_array_length (_tmp9_);
#line 77 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_parts_size_ = parts_length1;
#line 79 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp11_ = g_strdup (" ");
#line 79 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			split_char = _tmp11_;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp13_ = parts;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp13__length1 = parts_length1;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp14_ = _tmp13_[1];
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (g_strcmp0 (_tmp14_, "") != 0) {
#line 780 "updater.c"
				gchar** _tmp15_ = NULL;
				gint _tmp15__length1 = 0;
				const gchar* _tmp16_ = NULL;
				gboolean _tmp17_ = FALSE;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp15_ = parts;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp15__length1 = parts_length1;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp16_ = _tmp15_[1];
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp17_ = string_contains (_tmp16_, ":");
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp12_ = _tmp17_;
#line 795 "updater.c"
			} else {
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp12_ = FALSE;
#line 799 "updater.c"
			}
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp18_ = _tmp12_;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp18_) {
#line 805 "updater.c"
				gchar** time_parts = NULL;
				gchar** _tmp19_ = NULL;
				gint _tmp19__length1 = 0;
				const gchar* _tmp20_ = NULL;
				gchar** _tmp21_ = NULL;
				gchar** _tmp22_ = NULL;
				gint time_parts_length1 = 0;
				gint _time_parts_size_ = 0;
				gchar** _tmp23_ = NULL;
				gint _tmp23__length1 = 0;
				const gchar* _tmp24_ = NULL;
				gint _tmp25_ = 0;
				gchar** _tmp26_ = NULL;
				gint _tmp26__length1 = 0;
				const gchar* _tmp27_ = NULL;
				gint _tmp28_ = 0;
#line 83 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp19_ = parts;
#line 83 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp19__length1 = parts_length1;
#line 83 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp20_ = _tmp19_[1];
#line 83 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp22_ = _tmp21_ = g_strsplit (_tmp20_, ":", 2);
#line 83 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				time_parts = _tmp22_;
#line 83 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				time_parts_length1 = _vala_array_length (_tmp21_);
#line 83 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_time_parts_size_ = time_parts_length1;
#line 84 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp23_ = time_parts;
#line 84 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp23__length1 = time_parts_length1;
#line 84 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp24_ = _tmp23_[0];
#line 84 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp25_ = atoi (_tmp24_);
#line 84 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				h = _tmp25_;
#line 85 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp26_ = time_parts;
#line 85 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp26__length1 = time_parts_length1;
#line 85 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp27_ = _tmp26_[1];
#line 85 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp28_ = atoi (_tmp27_);
#line 85 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				min = _tmp28_;
#line 82 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				time_parts = (_vala_array_free (time_parts, time_parts_length1, (GDestroyNotify) g_free), NULL);
#line 858 "updater.c"
			}
#line 89 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp29_ = parts;
#line 89 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp29__length1 = parts_length1;
#line 89 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp30_ = _tmp29_[0];
#line 89 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp31_ = string_contains (_tmp30_, ".");
#line 89 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp31_) {
#line 870 "updater.c"
				gchar* _tmp32_ = NULL;
#line 90 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp32_ = g_strdup (".");
#line 90 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_g_free0 (split_char);
#line 90 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				split_char = _tmp32_;
#line 878 "updater.c"
			} else {
				gchar** _tmp33_ = NULL;
				gint _tmp33__length1 = 0;
				const gchar* _tmp34_ = NULL;
				gboolean _tmp35_ = FALSE;
#line 91 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp33_ = parts;
#line 91 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp33__length1 = parts_length1;
#line 91 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp34_ = _tmp33_[0];
#line 91 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp35_ = string_contains (_tmp34_, "-");
#line 91 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				if (_tmp35_) {
#line 894 "updater.c"
					gchar* _tmp36_ = NULL;
#line 92 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					_tmp36_ = g_strdup ("-");
#line 92 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					_g_free0 (split_char);
#line 92 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
					split_char = _tmp36_;
#line 902 "updater.c"
				}
			}
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp37_ = parts;
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp37__length1 = parts_length1;
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp38_ = _tmp37_[0];
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp39_ = split_char;
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp41_ = _tmp40_ = g_strsplit (_tmp38_, _tmp39_, 3);
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			date_parts = (_vala_array_free (date_parts, date_parts_length1, (GDestroyNotify) g_free), NULL);
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			date_parts = _tmp41_;
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			date_parts_length1 = _vala_array_length (_tmp40_);
#line 94 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_date_parts_size_ = date_parts_length1;
#line 95 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp42_ = date_parts;
#line 95 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp42__length1 = date_parts_length1;
#line 95 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp43_ = _tmp42_[1];
#line 95 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp44_ = atoi (_tmp43_);
#line 95 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			m = _tmp44_;
#line 96 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp45_ = date_parts;
#line 96 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp45__length1 = date_parts_length1;
#line 96 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp46_ = _tmp45_[2];
#line 96 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp47_ = strlen (_tmp46_);
#line 96 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp48_ = _tmp47_;
#line 96 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp48_ == 4) {
#line 945 "updater.c"
				gchar** _tmp49_ = NULL;
				gint _tmp49__length1 = 0;
				const gchar* _tmp50_ = NULL;
				gint _tmp51_ = 0;
				gchar** _tmp52_ = NULL;
				gint _tmp52__length1 = 0;
				const gchar* _tmp53_ = NULL;
				gint _tmp54_ = 0;
#line 97 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp49_ = date_parts;
#line 97 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp49__length1 = date_parts_length1;
#line 97 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp50_ = _tmp49_[2];
#line 97 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp51_ = atoi (_tmp50_);
#line 97 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				y = _tmp51_;
#line 98 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp52_ = date_parts;
#line 98 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp52__length1 = date_parts_length1;
#line 98 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp53_ = _tmp52_[0];
#line 98 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp54_ = atoi (_tmp53_);
#line 98 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				d = _tmp54_;
#line 974 "updater.c"
			} else {
				gchar** _tmp55_ = NULL;
				gint _tmp55__length1 = 0;
				const gchar* _tmp56_ = NULL;
				gint _tmp57_ = 0;
				gchar** _tmp58_ = NULL;
				gint _tmp58__length1 = 0;
				const gchar* _tmp59_ = NULL;
				gint _tmp60_ = 0;
#line 100 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp55_ = date_parts;
#line 100 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp55__length1 = date_parts_length1;
#line 100 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp56_ = _tmp55_[0];
#line 100 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp57_ = atoi (_tmp56_);
#line 100 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				y = _tmp57_;
#line 101 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp58_ = date_parts;
#line 101 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp58__length1 = date_parts_length1;
#line 101 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp59_ = _tmp58_[2];
#line 101 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp60_ = atoi (_tmp59_);
#line 101 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				d = _tmp60_;
#line 1004 "updater.c"
			}
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_g_free0 (split_char);
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			date_parts = (_vala_array_free (date_parts, date_parts_length1, (GDestroyNotify) g_free), NULL);
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1012 "updater.c"
		} else {
			gchar** parts = NULL;
			const gchar* _tmp61_ = NULL;
			gchar** _tmp62_ = NULL;
			gchar** _tmp63_ = NULL;
			gint parts_length1 = 0;
			gint _parts_size_ = 0;
			gboolean _tmp64_ = FALSE;
			gchar** _tmp65_ = NULL;
			gint _tmp65__length1 = 0;
			const gchar* _tmp66_ = NULL;
			gboolean _tmp70_ = FALSE;
			gchar** _tmp81_ = NULL;
			gint _tmp81__length1 = 0;
			const gchar* _tmp82_ = NULL;
			gint _tmp83_ = 0;
			gchar** _tmp84_ = NULL;
			gint _tmp84__length1 = 0;
			const gchar* _tmp85_ = NULL;
			gint _tmp86_ = 0;
			gint _tmp87_ = 0;
#line 104 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp61_ = self->priv->last_mod_meta;
#line 104 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp63_ = _tmp62_ = g_strsplit (_tmp61_, " ", 4);
#line 104 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts = _tmp63_;
#line 104 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts_length1 = _vala_array_length (_tmp62_);
#line 104 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_parts_size_ = parts_length1;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp65_ = parts;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp65__length1 = parts_length1;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp66_ = _tmp65_[3];
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp66_ != NULL) {
#line 1052 "updater.c"
				gchar** _tmp67_ = NULL;
				gint _tmp67__length1 = 0;
				const gchar* _tmp68_ = NULL;
				gboolean _tmp69_ = FALSE;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp67_ = parts;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp67__length1 = parts_length1;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp68_ = _tmp67_[3];
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp69_ = string_contains (_tmp68_, ":");
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp64_ = _tmp69_;
#line 1067 "updater.c"
			} else {
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp64_ = FALSE;
#line 1071 "updater.c"
			}
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp70_ = _tmp64_;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp70_) {
#line 1077 "updater.c"
				gchar** time_parts = NULL;
				gchar** _tmp71_ = NULL;
				gint _tmp71__length1 = 0;
				const gchar* _tmp72_ = NULL;
				gchar** _tmp73_ = NULL;
				gchar** _tmp74_ = NULL;
				gint time_parts_length1 = 0;
				gint _time_parts_size_ = 0;
				gchar** _tmp75_ = NULL;
				gint _tmp75__length1 = 0;
				const gchar* _tmp76_ = NULL;
				gint _tmp77_ = 0;
				gchar** _tmp78_ = NULL;
				gint _tmp78__length1 = 0;
				const gchar* _tmp79_ = NULL;
				gint _tmp80_ = 0;
#line 107 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp71_ = parts;
#line 107 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp71__length1 = parts_length1;
#line 107 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp72_ = _tmp71_[3];
#line 107 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp74_ = _tmp73_ = g_strsplit (_tmp72_, ":", 2);
#line 107 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				time_parts = _tmp74_;
#line 107 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				time_parts_length1 = _vala_array_length (_tmp73_);
#line 107 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_time_parts_size_ = time_parts_length1;
#line 108 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp75_ = time_parts;
#line 108 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp75__length1 = time_parts_length1;
#line 108 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp76_ = _tmp75_[0];
#line 108 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp77_ = atoi (_tmp76_);
#line 108 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				h = _tmp77_;
#line 109 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp78_ = time_parts;
#line 109 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp78__length1 = time_parts_length1;
#line 109 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp79_ = _tmp78_[1];
#line 109 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp80_ = atoi (_tmp79_);
#line 109 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				min = _tmp80_;
#line 106 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				time_parts = (_vala_array_free (time_parts, time_parts_length1, (GDestroyNotify) g_free), NULL);
#line 1130 "updater.c"
			}
#line 112 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp81_ = parts;
#line 112 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp81__length1 = parts_length1;
#line 112 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp82_ = _tmp81_[1];
#line 112 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp83_ = adblock_updater_get_month_from_string (self, _tmp82_);
#line 112 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			m = _tmp83_;
#line 113 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp84_ = parts;
#line 113 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp84__length1 = parts_length1;
#line 113 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp85_ = _tmp84_[2];
#line 113 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp86_ = strlen (_tmp85_);
#line 113 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp87_ = _tmp86_;
#line 113 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp87_ == 4) {
#line 1154 "updater.c"
				gchar** _tmp88_ = NULL;
				gint _tmp88__length1 = 0;
				const gchar* _tmp89_ = NULL;
				gint _tmp90_ = 0;
				gchar** _tmp91_ = NULL;
				gint _tmp91__length1 = 0;
				const gchar* _tmp92_ = NULL;
				gint _tmp93_ = 0;
#line 114 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp88_ = parts;
#line 114 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp88__length1 = parts_length1;
#line 114 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp89_ = _tmp88_[2];
#line 114 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp90_ = atoi (_tmp89_);
#line 114 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				y = _tmp90_;
#line 115 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp91_ = parts;
#line 115 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp91__length1 = parts_length1;
#line 115 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp92_ = _tmp91_[0];
#line 115 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp93_ = atoi (_tmp92_);
#line 115 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				d = _tmp93_;
#line 1183 "updater.c"
			} else {
				gchar** _tmp94_ = NULL;
				gint _tmp94__length1 = 0;
				const gchar* _tmp95_ = NULL;
				gint _tmp96_ = 0;
				gchar** _tmp97_ = NULL;
				gint _tmp97__length1 = 0;
				const gchar* _tmp98_ = NULL;
				gint _tmp99_ = 0;
#line 117 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp94_ = parts;
#line 117 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp94__length1 = parts_length1;
#line 117 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp95_ = _tmp94_[0];
#line 117 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp96_ = atoi (_tmp95_);
#line 117 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				y = _tmp96_;
#line 118 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp97_ = parts;
#line 118 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp97__length1 = parts_length1;
#line 118 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp98_ = _tmp97_[2];
#line 118 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp99_ = atoi (_tmp98_);
#line 118 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				d = _tmp99_;
#line 1213 "updater.c"
			}
#line 76 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1217 "updater.c"
		}
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp100_ = y;
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp101_ = m;
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp102_ = d;
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp103_ = h;
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp104_ = min;
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp105_ = g_date_time_new_local (_tmp100_, _tmp101_, _tmp102_, _tmp103_, _tmp104_, 0.0);
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp106_ = _tmp105_;
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		adblock_updater_set_last_updated (self, _tmp106_);
#line 122 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_g_date_time_unref0 (_tmp106_);
#line 1237 "updater.c"
	} else {
		GDateTime* _tmp107_ = NULL;
#line 133 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp107_ = now;
#line 133 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		adblock_updater_set_last_updated (self, _tmp107_);
#line 1244 "updater.c"
	}
#line 137 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp108_ = self->priv->expires_meta;
#line 137 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	if (_tmp108_ != NULL) {
#line 1250 "updater.c"
		const gchar* _tmp109_ = NULL;
		gboolean _tmp110_ = FALSE;
#line 138 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp109_ = self->priv->expires_meta;
#line 138 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp110_ = string_contains (_tmp109_, "days");
#line 138 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		if (_tmp110_) {
#line 1259 "updater.c"
			gchar** parts = NULL;
			const gchar* _tmp111_ = NULL;
			gchar** _tmp112_ = NULL;
			gchar** _tmp113_ = NULL;
			gint parts_length1 = 0;
			gint _parts_size_ = 0;
			GDateTime* _tmp114_ = NULL;
			gchar** _tmp115_ = NULL;
			gint _tmp115__length1 = 0;
			const gchar* _tmp116_ = NULL;
			gint _tmp117_ = 0;
			GDateTime* _tmp118_ = NULL;
			GDateTime* _tmp119_ = NULL;
#line 139 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp111_ = self->priv->expires_meta;
#line 139 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp113_ = _tmp112_ = g_strsplit (_tmp111_, " ", 0);
#line 139 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts = _tmp113_;
#line 139 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts_length1 = _vala_array_length (_tmp112_);
#line 139 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_parts_size_ = parts_length1;
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp114_ = self->priv->_last_updated;
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp115_ = parts;
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp115__length1 = parts_length1;
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp116_ = _tmp115_[0];
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp117_ = atoi (_tmp116_);
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp118_ = g_date_time_add_days (_tmp114_, _tmp117_);
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp119_ = _tmp118_;
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			adblock_updater_set_expires (self, _tmp119_);
#line 140 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_g_date_time_unref0 (_tmp119_);
#line 138 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1303 "updater.c"
		} else {
			const gchar* _tmp120_ = NULL;
			gboolean _tmp121_ = FALSE;
#line 141 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp120_ = self->priv->expires_meta;
#line 141 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			_tmp121_ = string_contains (_tmp120_, "hours");
#line 141 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
			if (_tmp121_) {
#line 1313 "updater.c"
				gchar** parts = NULL;
				const gchar* _tmp122_ = NULL;
				gchar** _tmp123_ = NULL;
				gchar** _tmp124_ = NULL;
				gint parts_length1 = 0;
				gint _parts_size_ = 0;
				GDateTime* _tmp125_ = NULL;
				gchar** _tmp126_ = NULL;
				gint _tmp126__length1 = 0;
				const gchar* _tmp127_ = NULL;
				gint _tmp128_ = 0;
				GDateTime* _tmp129_ = NULL;
				GDateTime* _tmp130_ = NULL;
#line 142 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp122_ = self->priv->expires_meta;
#line 142 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp124_ = _tmp123_ = g_strsplit (_tmp122_, " ", 0);
#line 142 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				parts = _tmp124_;
#line 142 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				parts_length1 = _vala_array_length (_tmp123_);
#line 142 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_parts_size_ = parts_length1;
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp125_ = self->priv->_last_updated;
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp126_ = parts;
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp126__length1 = parts_length1;
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp127_ = _tmp126_[0];
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp128_ = atoi (_tmp127_);
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp129_ = g_date_time_add_hours (_tmp125_, _tmp128_);
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_tmp130_ = _tmp129_;
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				adblock_updater_set_expires (self, _tmp130_);
#line 143 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				_g_date_time_unref0 (_tmp130_);
#line 141 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1357 "updater.c"
			}
		}
	} else {
		gint days_to_expire = 0;
		GDateTime* _tmp131_ = NULL;
		gint _tmp132_ = 0;
		GDateTime* _tmp133_ = NULL;
		GDateTime* _tmp134_ = NULL;
#line 147 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		days_to_expire = 7;
#line 148 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp131_ = self->priv->_last_updated;
#line 148 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp132_ = days_to_expire;
#line 148 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp133_ = g_date_time_add_days (_tmp131_, _tmp132_);
#line 148 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_tmp134_ = _tmp133_;
#line 148 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		adblock_updater_set_expires (self, _tmp134_);
#line 148 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		_g_date_time_unref0 (_tmp134_);
#line 1380 "updater.c"
	}
#line 152 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp135_ = now;
#line 152 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp136_ = self->priv->_expires;
#line 152 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp137_ = g_date_time_compare (_tmp135_, _tmp136_);
#line 152 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_set_needs_update (self, _tmp137_ == 1);
#line 67 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_date_time_unref0 (now);
#line 1392 "updater.c"
}


GDateTime* adblock_updater_get_last_updated (AdblockUpdater* self) {
	GDateTime* result;
	GDateTime* _tmp0_ = NULL;
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = self->priv->_last_updated;
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	result = _tmp0_;
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return result;
#line 1407 "updater.c"
}


static gpointer _g_date_time_ref0 (gpointer self) {
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 1414 "updater.c"
}


void adblock_updater_set_last_updated (AdblockUpdater* self, GDateTime* value) {
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_if_fail (self != NULL);
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = value;
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_date_time_unref0 (self->priv->_last_updated);
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self->priv->_last_updated = _tmp1_;
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_object_notify ((GObject *) self, "last-updated");
#line 1433 "updater.c"
}


GDateTime* adblock_updater_get_expires (AdblockUpdater* self) {
	GDateTime* result;
	GDateTime* _tmp0_ = NULL;
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = self->priv->_expires;
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	result = _tmp0_;
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return result;
#line 1448 "updater.c"
}


void adblock_updater_set_expires (AdblockUpdater* self, GDateTime* value) {
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_if_fail (self != NULL);
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = value;
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_date_time_unref0 (self->priv->_expires);
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self->priv->_expires = _tmp1_;
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_object_notify ((GObject *) self, "expires");
#line 1467 "updater.c"
}


gboolean adblock_updater_get_needs_update (AdblockUpdater* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = self->priv->_needs_update;
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	result = _tmp0_;
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	return result;
#line 1482 "updater.c"
}


void adblock_updater_set_needs_update (AdblockUpdater* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_return_if_fail (self != NULL);
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_tmp0_ = value;
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self->priv->_needs_update = _tmp0_;
#line 19 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_object_notify ((GObject *) self, "needs-update");
#line 1496 "updater.c"
}


static void adblock_updater_class_init (AdblockUpdaterClass * klass) {
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	adblock_updater_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_type_class_add_private (klass, sizeof (AdblockUpdaterPrivate));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	ADBLOCK_FEATURE_CLASS (klass)->clear = adblock_updater_real_clear;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	ADBLOCK_FEATURE_CLASS (klass)->header = adblock_updater_real_header;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	ADBLOCK_FEATURE_CLASS (klass)->parsed = adblock_updater_real_parsed;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_adblock_updater_get_property;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_adblock_updater_set_property;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	G_OBJECT_CLASS (klass)->finalize = adblock_updater_finalize;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_UPDATER_LAST_UPDATED, g_param_spec_boxed ("last-updated", "last-updated", "last-updated", G_TYPE_DATE_TIME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_UPDATER_EXPIRES, g_param_spec_boxed ("expires", "expires", "expires", G_TYPE_DATE_TIME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADBLOCK_UPDATER_NEEDS_UPDATE, g_param_spec_boolean ("needs-update", "needs-update", "needs-update", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1523 "updater.c"
}


static void adblock_updater_instance_init (AdblockUpdater * self) {
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self->priv = ADBLOCK_UPDATER_GET_PRIVATE (self);
#line 1530 "updater.c"
}


static void adblock_updater_finalize (GObject* obj) {
	AdblockUpdater * self;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ADBLOCK_TYPE_UPDATER, AdblockUpdater);
#line 15 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_free0 (self->priv->expires_meta);
#line 16 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_free0 (self->priv->last_mod_meta);
#line 17 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_date_time_unref0 (self->priv->_last_updated);
#line 18 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	_g_date_time_unref0 (self->priv->_expires);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	G_OBJECT_CLASS (adblock_updater_parent_class)->finalize (obj);
#line 1548 "updater.c"
}


GType adblock_updater_get_type (void) {
	static volatile gsize adblock_updater_type_id__volatile = 0;
	if (g_once_init_enter (&adblock_updater_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AdblockUpdaterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adblock_updater_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdblockUpdater), 0, (GInstanceInitFunc) adblock_updater_instance_init, NULL };
		GType adblock_updater_type_id;
		adblock_updater_type_id = g_type_register_static (ADBLOCK_TYPE_FEATURE, "AdblockUpdater", &g_define_type_info, 0);
		g_once_init_leave (&adblock_updater_type_id__volatile, adblock_updater_type_id);
	}
	return adblock_updater_type_id__volatile;
}


static void _vala_adblock_updater_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AdblockUpdater * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ADBLOCK_TYPE_UPDATER, AdblockUpdater);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		case ADBLOCK_UPDATER_LAST_UPDATED:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		g_value_set_boxed (value, adblock_updater_get_last_updated (self));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		case ADBLOCK_UPDATER_EXPIRES:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		g_value_set_boxed (value, adblock_updater_get_expires (self));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		case ADBLOCK_UPDATER_NEEDS_UPDATE:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		g_value_set_boolean (value, adblock_updater_get_needs_update (self));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 1587 "updater.c"
		default:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 1593 "updater.c"
	}
}


static void _vala_adblock_updater_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AdblockUpdater * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ADBLOCK_TYPE_UPDATER, AdblockUpdater);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		case ADBLOCK_UPDATER_LAST_UPDATED:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		adblock_updater_set_last_updated (self, g_value_get_boxed (value));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		case ADBLOCK_UPDATER_EXPIRES:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		adblock_updater_set_expires (self, g_value_get_boxed (value));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		case ADBLOCK_UPDATER_NEEDS_UPDATE:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		adblock_updater_set_needs_update (self, g_value_get_boolean (value));
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 1621 "updater.c"
		default:
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/midori-0.5.8/extensions/adblock/updater.vala"
		break;
#line 1627 "updater.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



